﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;

namespace WpfApplication2
{
	/// <summary>
	/// Interaction logic for PagerUserControl.xaml
	/// </summary>
	public partial class PagerUserControl : UserControl, INotifyPropertyChanged
	{
		public PagerUserControl()
		{
			InitializeComponent();
		}

        private void RadioButton_Click(object sender, RoutedEventArgs e)
        {
            CurrentPage = Convert.ToInt32(((RadioButton) sender).Content) - 1;
        }

        private void ComboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            PageSize = Convert.ToInt32(((ListBoxItem) (PageSizeCombo.SelectedItem)).Content);
        }

        private void ChangePage(object sender, RoutedEventArgs e)
        {
            if (sender == First && CurrentPage != 0)
            {
                CurrentPage = 0;
            }
            else if (sender == Previous && CurrentPage > 0)
            {
                CurrentPage--;
            }
            else if (sender == Next && CurrentPage < PagerNumbers.Items.Count - 1)
            {
                CurrentPage++;
            }
            else if (sender == Last && CurrentPage != PagerNumbers.Items.Count - 1)
            {
                CurrentPage = PagerNumbers.Items.Count - 1;
            }
        }

        private int pageSize = 25;
        public int PageSize 
        { 
            get
            {
                return pageSize;
            }
            set
            {
                if(pageSize != value)
                {
                    pageSize = value;
                    currentPage = 0;
                }
                OnPropertyChanged("PageSize");
            }
        }

        private int currentPage = 0;
        public int CurrentPage 
        { 
            get
            {
                return currentPage;
            }
            set
            {
                if(currentPage != value)
                {
                    currentPage = value;
                }
                OnPropertyChanged("CurrentPage");
            }
        }    
        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        private void OnPropertyChanged(string name)
        {
            if(PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(name));
            }
        }
    }
}
