﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Windows.Controls.Primitives;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GridView;
using Telerik.Windows.Data;
using System.Collections.Specialized;

namespace WpfApplication2
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        NorthwindEntities1 context = null;
        QueryableCollectionView view = null;

        public Window1()
        {
            InitializeComponent();

            context = new NorthwindEntities1();
            
            view = new QueryableCollectionView(context.Customers);

            view.CollectionChanged += new NotifyCollectionChangedEventHandler(view_CollectionChanged);

            PagerUserControl1.PropertyChanged += new PropertyChangedEventHandler(PagerUserControl1_PropertyChanged);

            GetData();
       }

        void view_CollectionChanged(object sender, NotifyCollectionChangedEventArgs e)
        {
            BuildPagerNumbers();
        }

        void PagerUserControl1_PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            GetData();
        }

        private void GetData()
        {
            if (view.SortDescriptors.Count == 0)
            {
                view.SortDescriptors.Add(new SortDescriptor() { Member = "CustomerID" });
            }

            view.PageSize = PagerUserControl1.PageSize;
            view.MoveToPage(PagerUserControl1.CurrentPage);

            BuildPagerNumbers();

            if (RadGridView1.ItemsSource == null)
            {
                RadGridView1.ItemsSource = view;
            }
        }

        private void BuildPagerNumbers()
        {
            PagerUserControl1.PagerNumbers.ItemsSource = 
                from i in Enumerable.Range(1, view.TotalItemCount / PagerUserControl1.PageSize + 1)
                                                         select i;
        }
    }
}